use Evo::Base -strict;
use Promises;
use Promises6;
use List::Util 'first';
use Mojo::IOLoop;
use POSIX 'ceil';
use Proc::ProcessTable;
use Time::Piece;

# the test is terrible. don't blame me.

sub gen_promise {
  my ($d_sub, $n, $data) = @_;

  my $deferred = $d_sub->();
  my $p        = $deferred->promise;

  Mojo::IOLoop->next_tick(sub { $deferred->resolve($data) });

  foreach my $i (1 .. $n) {
    save_mem($i) unless $i % 1000;
    $p = $p->then(
      sub($v) {
        save_mem($i) unless $i % 1000;
        $v;
      }
    );
  }

  $p->then(sub($v) { save_mem(); $v; });
}

my $MAX_MEM = 0;

sub wait_promise {
  my ($d_sub, $N, $VAL) = @_;

  my $result;
  gen_promise($d_sub, $N, $VAL)->then(sub($v) { $result = "$v-done" })
    ->then(sub { print_mem_info(); EV::break });
  EV::run;

}

my $chain_count = $ENV{CHAIN_COUNT} // 100_000;
my $data_size   = $ENV{DATA_SIZE}   // 100_000;

$chain_count =~ s/_//g;
$data_size =~ s/_//g;

my $VAL = rand() x $data_size;

sub save_mem($i) {
  state $pt = Proc::ProcessTable->new('cache_ttys' => 1);
  my $table = first { $_->pid == $$ } $pt->table->@*;
  $MAX_MEM = $table->rss if $table->rss > $MAX_MEM;

  my $MB = $MAX_MEM / 1024 / 1024;
  say "passed $i from $chain_count; mem: $MB mb" unless $i % 10000;
  die "Too much mem" if $MB > 3000;
  $MAX_MEM;
}

say "info:CHAIN_COUNT=$chain_count DATA_SIZE=$data_size perl -Ilib $0 ";

FOO: {

  my $d_sub_my  = \&Promises6::deferred;
  my $d_sub_bad = \&Promises::deferred;
  my ($start, $end);

  $start = localtime;
  say "Starting Promises6";
  do { wait_promise($d_sub_my, $chain_count, $VAL) };
  $end = localtime;
  say "Done in: ", $end - $start, " seconds";
  say "Max. mem. : " . ceil($MAX_MEM / 1024 / 1024) . " MB";

  $start = localtime;
  say "Starting Promises. Dangerous, could use all of your memory";
  do { wait_promise($d_sub_bad, $chain_count, $VAL) };
  $end = localtime;
  say "Done in: ", $end - $start, " seconds";
  say "Max. mem. : " . ceil($MAX_MEM / 1024 / 1024) . " MB";
}


