use Evo::Base -strict;
use Test::More;

BEGIN {
  plan skip_all => 'set TEST_EV env to enable this test' unless $ENV{TEST_EV};
}

plan tests => 2;
use Promises6::EV::Builder;
use EV;

my $bldr = Promises6::EV::Builder->new;

# from blocking
my $safe;
$safe = EV::timer 1, 0, sub { fail; EV::break };
my $d = $bldr->deferred;

$d->promise->then(sub { is EV::depth, 1; })->then(
  sub {
    is EV::depth, 1;
    my $fail_w;
    $fail_w = EV::timer 0, 0, sub { undef $fail_w; fail };
  }
);
$d->resolve(1);

done_testing;
